
package de.ivu.elect.presentation.wahl.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlEdit;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.jee.faces.FacesContextUtil;

@Named(WahlEntsperrenAction.COMPONENT_NAME)
public class WahlEntsperrenAction extends AbstractWahlAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlEntsperrenAction";

  @Inject
  private transient WahlEdit wahlEdit;

  @Override
  public UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHL_ENTSPERREN;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Wahl entity) {
    return super.isDisabledInternal(entity) || !entity.getStatus().isGesperrt();
  }

  @Override
  public String doIt(Wahl wahl) {
    wahlEdit.wahlEntsperren(wahl);

    messages.addInfoMessage("wahl.edit.action.unlock.success.message", wahl.getName());

    return FacesContextUtil.getCurrentViewId();
  }

  @Override
  public boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getLabelKey() {
    return "wahl.edit.action.unlock";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconUnlock();
  }
}
